/*-------------------------------------------------------------------------*\

   BinSExpr.h

   Binary String Expression - this describes a binary expression on two
   two strings whose result is a string.

   Copyright (C) 1996 by Michael A. Muller
      
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
      
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
      

\*-------------------------------------------------------------------------*/

#file BinSExpr

#intinclude Expr
#intinclude Ptrs

class BinSExpr : public Expr  {
   protected:
      ObjPtr<Expr> expr1, expr2;

   public:      
      BinSExpr(Expr *expr10, Expr *expr20) :
               expr1(expr10),
               expr2(expr20)
         {
         if (!expr1->isStringExpr() || !expr2->isStringExpr())
            throw 0;
         }

      virtual bool isStringExpr() const
         {
         return true;
         }
   }

