/*-------------------------------------------------------------------------*\

   GrowBuf.h

   GrowableBuffer's allow you to add characters to a static buffer without
   regard for it's size: if the buffer size is exceeded it simply allocates
   a new buffer and uses it instead of the supplied static buffer.

   Copyright (C) 1996 by Michael A. Muller
      
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
      
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.      

\*-------------------------------------------------------------------------*/

#file GrowBuf

#impinclude string

class GrowableBuffer {
   private:
      char *buf, *orig;
      unsigned cur, size;
   public:
      GrowableBuffer(char *buf, unsigned size) :
         buf(buf), orig(buf), size(size), cur(0)
			{
			}

      ~GrowableBuffer()
			{
			if (orig != buf) delete [] buf;
			}
		
      void addChar(char c)
         {
         if (cur == size) {
            char *last = buf;
            buf = new char[size *= 2];
            strncpy(buf, last, cur);
            if (last != orig)
               delete [] last;
            }
         buf[cur++] = c;
         }

      char *getData()
         {
         char *hisData = new char[cur];
         strncpy(hisData, buf, cur);
         return hisData;
         }
   }
