/*-------------------------------------------------------------------------*\

   NotExpr.h

   Not Expression - an expression which logically negates its operand.

   Copyright (C) 1996 by Michael A. Muller
      
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
      
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.      

\*-------------------------------------------------------------------------*/
#file NotExpr

#intinclude Expr
#intinclude Ptrs

#impinclude StrVal

class NotExpr : public Expr {
   private:
      ObjPtr<Expr> expr;
      
   public:
      NotExpr(Expr *expr0) :
            Expr(),
            expr(expr0)
         {
         if (!expr->isStringExpr())
            throw 0;
         }
         
      virtual ClassId classId() const
         {
         return ClassIds::NotExpr;
         }

      virtual bool isStringExpr() const
         {
         return true;
         }
         
      virtual Value *evaluate() const
         {
         ObjPtr<StrVal> s((StrVal*)expr->evaluate());
         return new StrVal(s->length() ? "" : "true");
         }

   }
