/*-------------------------------------------------------------------------*\

   OrExpr.h

	Or expression - a binary expression which returns true if either of its
	operands are true.

   Copyright (C) 1996 by Michael A. Muller
      
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
      
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.      

\*-------------------------------------------------------------------------*/


#file OrExpr

#intinclude BinSExpr
#impinclude StrVal

class OrExpr : public BinSExpr {
   public:
      OrExpr(Expr *expr1, Expr *expr2) :
            BinSExpr(expr1, expr2)
         {
         }
         
      virtual ClassId classId() const
         {
         return ClassIds::SbstExpr;
         }
         
      virtual Value *evaluate() const
         {
         ObjPtr<StrVal> s1((StrVal*)expr1->evaluate());
         ObjPtr<StrVal> s2((StrVal*)expr2->evaluate());
         return new StrVal((s1->length() || s2->length()) ? "true" : "");
         }
      
   }
