/*-------------------------------------------------------------------------*\

   StrVar.h

   String Variable - a Variable whose value is a String.
   
   Copyright (C) 1996, Michael A. Muller

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
      
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.      

\*-------------------------------------------------------------------------*/

#file StrVar

#intinclude Var

#impinclude StrVal

class StrVar : public Var {
   private:
      String _val;

   public:
      StrVar(const char *name, const char *val0) :
            Var(name),
            _val(val0)
         {
         }
      
      const String &val() const
         {
         return _val;
         }
         
      StrVar &val(const char *newVal)
         {
         _val = newVal;
         return *this;
         }
         
      virtual ClassId classId() const
			{
			return ClassIds::StrVar;
			}
      
      virtual Value *evaluate() const
		   {
		   return new StrVal(_val);
		   }
      
      virtual bool isStringExpr() const
         {
         return true;
         }
      
      virtual Var *copy() const
         {
         return new StrVar(*this);
         }
      }

