/*-------------------------------------------------------------------------*\

   Table.d

   a grunt Table consists of a header Row and a sequence of body Row's.
   Uses the GPP list interface.

   Copyright (C) 1996, Michael A. Muller

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
      
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.      

\*-------------------------------------------------------------------------*/

#file Table

#intinclude SLList
#intinclude Row

class Table : public SLList<Row> {
   private:
      unsigned _numColumns;
      ObjPtr<Row> _headers;
   
   public:
      Table(unsigned numColumns0) :
            _numColumns(numColumns0)
         {
         }
         
      Table(const Table &other) :
            SLList<Row>(other),
            _numColumns(other.numColumns()),
            _headers(new Row(other.headers()))
         {
         }
      
      // adds a new row to the table and returns it for the caller to populate
      Row &newRow()
         {
         append(Row(numColumns()));
         return rear();
         }

      // given an orphan 'newHeaders', sets the headers for the table
      Table &headers(Row *newHeaders)
         {
         ObjPtr<Row> temp(newHeaders);
         _headers = temp;
         return *this;
         }
         
      const Row &headers() const
         {
         return *_headers;
         }
         
      unsigned numColumns() const
         {
         return _numColumns;
         }
      }
