/*-------------------------------------------------------------------------*\

   TableVar.d

   Table Variable - a variable whose value is a table.
   
   Copyright (C) 1996, Michael A. Muller

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
      
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.      

\*-------------------------------------------------------------------------*/

#file TableVar

#intinclude Var
#intinclude Table

#impinclude TableVal

class TableVar : public Var, public Table {
   public:
      TableVar(const char *name, unsigned numCols) :
            Var(name),
            Table(numCols)
         {
         }
      
      TableVar(const char *name, const Table &other) :
            Var(name),
            Table(other)
         {
         }

      virtual ClassId classId() const
         {
         return ClassIds::TableVar;
         }
         
      virtual Value *evaluate() const
         {
         return new TableVal(*this);
         }
         
      virtual bool isStringExpr() const
         {
         return false;
         }
         
      virtual Var *copy() const
         {
         return new TableVar(*this);
         }
   }
