# Copyright (C) Michael A. Muller 2002
# This file holds things that I have found generally useful in GNU makefiles.
# it should be included before any targets, but after all local definitions

ifndef PROJ_LBL
$(error You must define a PROJ_LBL variable)
endif

ifndef PROJ_SRC_ROOT
$(error You must define a PROJ_SRC_ROOT variable)
endif

# complete project source path (to extract the project from CVS)
PROJ_SRC_PATH = $(PROJ_SRC_ROOT)$(PROJ_SRC_BRANCH)

# Version label suitable for CVS.
VER_LBL = $(PROJ_LBL)-$(subst .,-,$(VER))

# temporary directory (used for extracting source tree to build distribution)
BUILD_TMP = build-tmp

# tmporary source path (for building under temporary directory)
TMP_SRC_PATH = $(BUILD_TMP)/$(PROJ_SRC_PATH)

# macro to check to make sure that VER is passed in on the command line
define check_ver
if [ "$(VER)" = "" ]; then \
	echo "You must set the 'VER' variable"; \
	exit 1; \
fi
endef

# macro to check to make sure that all modifications are checked into CVS
# and to warn if files exist in the current directory that are not the
# latest versions in CVS
define check_cvs_files
	if cvs status | grep ^File | \
	   egrep -v "Status: (Up-to-date|Needs Patch)" >/dev/null; \
	then \
		echo "*** Error: Not all files are checked in ***"; \
		exit 1; \
	fi
	if cvs status | grep ^File | \
	   grep "Status: Needs Patch" >/dev/null; \
	then \
		echo "*** Warning: Files in the current directory are not the latest. Continue? ***"; \
		read answer; \
		case $$answer in \
			[yY]*) ;; \
			*) exit 1 ;; \
		esac; \
	fi
endef
