/*
	This is only enough of a diff to satisfy "mx". Do not even think
	about using it for anything else.
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>

void CompareLine(FILE *f1, FILE *f2)
	{
	/* ignore leading whitespace */
	int c1, c2;
	do 
		{
		c1 = fgetc(f1);
		}
	while (c1 != EOF && isspace(c1) && c1 != '\n');
	
	do
		{
		c2 = fgetc(f2);
		}
	while (c2 != EOF && isspace(c2) && c2 != '\n');
	
	while (1)
		{
		/* if the current characters are not the same */ 
		if (c1 != c2)
			/* if they are both whitespace, go into whitespace comparison mode */
			if (isspace(c1) && isspace(c2))
				break;
			
			/* if not, the files are different */
			else
				exit(1);
	
		/* if both characters (we know they are the same) are newlines, the lines
		 * are the same.
		 */
		if (c1 == '\n')
			return;
		
		/* if both characters are EOF, the files are the same. */
		if (c1 == EOF)
			exit(0);
		
		c1 = fgetc(f1);
		c2 = fgetc(f2);
		}
	
	/* whitespace comparison mode */
	while (1)
		{
		/* get the next character if the last character was not newline or EOF */
		if (c1 != '\n' && c1 != EOF)
			c1 = fgetc(f1);
		if (c2 != '\n' && c2 != EOF)
			c2 = fgetc(f2);
		
		/* if either character is not whitespace or EOF, the files are different
		 */
		if (!isspace(c1) && c1 != EOF || !isspace(c2) && c2 != EOF)
			exit(1);
		
		/* if both characters are newline, the lines are the same. */
		else if (c1 == '\n' && c2 == '\n')
			return;
		
		/* if both characters are EOF, the files are the same */
		else if (c1 == EOF && c2 == EOF)
			exit(0);
		
		/* if either character is newline and the other is EOF, the files
		 * are different.
		 */
		else if (c1 == EOF && c2 == '\n' ||
					c2 == EOF && c1 == '\n')
			exit(1);
		}
	}
	
	

main(int argc, char **argv)
	{
	FILE *f1, *f2;
	if (argc != 4)
		{
		printf("Apparently you are so foolish as to use this bogus diff for a "
				 "purpose other than that for which it was designed.");
		exit(1);
		}
		
	f1 = fopen(argv[2], "r");
	f2 = fopen(argv[3], "r");

	if (!f1 || !f2)
		exit(1);

	while (1)
		CompareLine(f1, f2);
	}